// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//.Version October 1, 2006 |
//------------------------------------------------------------------
//| GetDigVelue.mqh |
//| Copyright ? 2006, Nikolay Kositsin |
//| Khabarovsk, farria@mail.redcom.ru |
//------------------------------------------------------------------
/*
SSSSSSS SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

----------------------------- the designation of-------------------------------

Function GetDigVelue() is intended for the discreteness of the valuesof variables with the floating point
File should be placed into folder MetaTrader\.experts\.include \
  
-------------------------- the input parameters of--------------------------

GetDigVelue.STEP - step of the discreteness
GetDigVelue.Velue - parameter, the discreteness of value of whichshould be produced

------------------------- the output parameters of---------------------------

GetDigVelue(() - the value of function GetDigVelue - theotsifrovannoye value of the input parameter GetDigVelue.Velue
  
------------------------- of ---------------------------
*/

//---------------------------------------------------------------------------------------------------------------------------
// introduction to function GetDigVelue
double GetDigVelue(double GetDigVelue_STEP, double GetDigVelue_Velue)
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 {
   double GetDigVelue_TempVelue=GetDigVelue_Velue;
   GetDigVelue_TempVelue/=GetDigVelue_STEP;
   GetDigVelue_TempVelue=NormalizeDouble(GetDigVelue_TempVelue,0);
   GetDigVelue_TempVelue*=GetDigVelue_STEP;
   return(GetDigVelue_TempVelue);
 }
//---------------------------------------------------------------------------------------------------------------------------

