//Version  January 7, 2009 Final
//+X================================================================X+
//|                                                 JurXSeries().mqh |
//|                      JurX code: Copyright  1998, Jurik Research |
//|                                          http://www_jurikres.com | 
//|    JurXSeries()MQL4 CODE: Copyright  2009,     Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
  /*
  
  +-------------------------------------- <<<  JurXSeries() >>> -----------------------------------------------+

  +-----------------------------------------+ <<<  >>> +----------------------------------------------------+

    JurXSeries()         JurX      
  ,               .      
    ,            JRSX.      ():
  MetaTrader\experts\include\    ,    nJurX.bar ,  nJurX.MaxBar-3*nJurX.Length,  
  JurXSeries()     !   ! , ,     
      -     !    JurXSeries()    
        ,        .       JurXSeries()
         ,        
          !         JurXSeries, 
              nJurX....    dJurX....   JurXSeries()  
        ,       ,   
                 JurXSeries()     
  (nJurX.number). 
  

  +-------------------------------------+ <<<   >>> +-------------------------------------------------+

  nJurX.number -      JurX.Series(). (0, 1, 2, 3 ......)
  nJurX.din -    ,    nJurX.Length   . 0 -   , 
                    - .
  nJurX.MaxBar -   ,            (bar).      
                 Bars-1-period;   "period" -   ,       dJurX.series 
                  ;
  nJurX.limit -                   ,   
                  Bars-IndicatorCounted()-1;
  nJurX.Length -  
  dJurX.series -   ,      JurXSeries();
  nJurX.bar -       ,            
                 .            nJurX.limit!!!

  +------------------------------------+ <<<   >>> +-------------------------------------------------+

  JurXSeries() -   dJurX.      nJurX.bar       nJurX.MaxBar-nJurX.Length     
                 JurXSeries()   !!!
  nJurX.reset -  ,    ,    0 ,      ,
                 0,    .      ,   !!!

  +-----------------------------------+ <<<   >>> +-----------------------------------------------+

      JurXSeries(),       0, (     
            )          
     ,               JurXSeries()      
  JurXSeriesResize()         :  JurXSeriesResize(nJurX.number+1);      
  nJurX.number(MaxJurX.number)            JurXSeries,       , 
   nJurX.number. 
  
  +--------------------------------------+ <<<   >>> +-------------------------------------------------+
  
           ,       
  .       JurXSeries()       \MetaTrader\EXPERTS\LOGS\. ,   
    JurXSeries()   ,   ,  MQL4 ,       
      .     JurXSeries()   JurXSeries()  MQL4 ,
                   .      
    JurXSeries()  nJurX.number        nJurXResize.Size   
         .        
      nJurX.limit.         init()    
          JurXSeries(),    JurXSeriesResize()      
         .      JurXSeries()   
           nJurX.bar,        
  .  ,            
    ,      JurXSeries()         ,      
    .       JurXSeries()       
        .        
     ,       init(). 
  
  +---------------------------------+ <<<     >>> +--------------------------------------------+


//----+   JurXSeries()
#include <JurXSeries.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----    
SetIndexStyle (0,DRAW_LINE); 
//---- 1      (    JurXSeries()     !!!)
SetIndexBuffer(0,Ind_Buffer);
//----+      JurXSeries, nJurX.number=1(    JurXSeries)
if(JurXSeriesResize(1)==0)return(-1);
return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int start()
{
//----+        
int reset,bar,MaxBar,limit,counted_bars=IndicatorCounted(); 
//----    
if (counted_bars<0)return(-1);
//----       
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+ 
for(bar=limit;bar>=0;bar--)
 (
  double Series=Close[bar];
  //----+    JurXSeries()  0    Ind_Buffer[], 
  // nJurX.Phase  nJurX.Length      (nJurX.din=0)
  double Resalt=JurXSeries(0,0,MaxBar,limit,Length,Series,bar,reset);
  if (reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+ 

*/
//+X================================================================X+
//|  JurXSeries() function                                           |
//+X================================================================X+    

//----++ <<<     >>> +-------------------+
double dJurX_f1[1], dJurX_f2[1], dJurX_f3[1], dJurX_f4[1], dJurX_f5[1];
double dJurX_f6[1], dJurX_Kg[1], dJurX_Hg[1], dJurX_F1[1], dJurX_F2[1];
double dJurX_F3[1], dJurX_F4[1], dJurX_F5[1], dJurX_F6[1];
int    nJurX_w [1], nJurX_TIME[1], nJurX_Error, nJurX_Tnew, nJurX_Told;
double dJurX_VEL1, dJurX_VEL2, dJurX_JurX, nJurX_Resize;
//----++ +---------------------------------------------------------------+
//----++ <<<   JurXSeries() >>> +-------------------------+
double JurXSeries
 (
  int nJurX_number,int    nJurX_din,    int nJurX_MaxBar, int  nJurX_limit,
  int nJurX_Length,double dJurX_series, int nJurX_bar,    int& nJurX_reset
 )
//----++-------------------------------------------------------------------+
{
nJurX_reset = 1;
//=====+ <<<    >>> --------------------------------------------------------------------+
if (nJurX_bar == nJurX_limit)
 {
  //----++     JurXSeries()
  if(nJurX_Resize < 1)
   {
    Print(StringConcatenate("JurXSeries number = ",nJurX_number,
         "_         JurXSeriesResize()"));
    if(nJurX_Resize == 0)
        Print(StringConcatenate("JurXSeries number = ",nJurX_number,
                "_      JurXSeriesResize()   "));
         
    return(0.0);
   }
  //----++       ,   JurXSeries()
  nJurX_Error = GetLastError();
  if(nJurX_Error > 4000)
   {
      Print(StringConcatenate("JurXSeries number = ",nJurX_number,
            "_  ,     JurXSeries() number = ",
                                                                      nJurX_number," !!! "));
      Print(StringConcatenate("JurXSeries number = ",nJurX_number,"_ ", JurX_ErrDescr(nJurX_Error))); 
   } 

  //----++       nJurX_number  nJurXResize_Size
  if (ArraySize(dJurX_f1) < nJurX_number) 
   {
    Print(StringConcatenate("JurXSeries number = ",nJurX_number,
                "_ !!!     nJurX_number  JurXSeries()"));
    Print(StringConcatenate("JurXSeries number = ",nJurX_number,
           "_       nJurXResize_Size  JurXSeriesResize()"));
    return(0.0);
   }
 }
//----++ +-----------------------------------------------------------------------------------------------+ 
 
if (nJurX_bar > nJurX_MaxBar){nJurX_reset = 0; return(0.0);}
if (nJurX_bar == nJurX_MaxBar || nJurX_din != 0)
 {
  //----++ <<<    >>> +------------------+
  if (nJurX_Length <1  ) nJurX_Length = 1;
  if (nJurX_Length >= 6) 
             nJurX_w[nJurX_number] = nJurX_Length - 1; 
  else nJurX_w[nJurX_number] = 5; 
  dJurX_Kg[nJurX_number] = 3 / (nJurX_Length + 2.0); 
  dJurX_Hg[nJurX_number] = 1.0 - dJurX_Kg[nJurX_number];
  //----++--------------------------------------------------+
 }
//----++        nJurX_bar
if (nJurX_limit >= nJurX_MaxBar)
 if (nJurX_bar == 0)
  if (nJurX_din == 0)
   if (nJurX_MaxBar > 3 * nJurX_Length)
    if (nJurX_TIME[nJurX_number] == 0)
              Print(StringConcatenate("JurXSeries number = ",nJurX_number,
                              "_ !!!   ", 
                                 "   nJurX_bar   !!!"));  
//----++      
if (nJurX_bar == nJurX_limit)
 if (nJurX_limit < nJurX_MaxBar)          
  {
  //----+ <<<    >>> +-------------------------------------------------+
   nJurX_Tnew = Time[nJurX_limit + 1];
   nJurX_Told = nJurX_TIME[nJurX_number];
   //--+
   if (nJurX_Tnew == nJurX_Told)
     {
      dJurX_f1[nJurX_number] = dJurX_F1[nJurX_number]; dJurX_f2[nJurX_number] = dJurX_F2[nJurX_number]; 
      dJurX_f3[nJurX_number] = dJurX_F3[nJurX_number]; dJurX_f4[nJurX_number] = dJurX_F4[nJurX_number]; 
      dJurX_f5[nJurX_number] = dJurX_F5[nJurX_number]; dJurX_f6[nJurX_number] = dJurX_F6[nJurX_number];
     }
   //--+   
   if(nJurX_Tnew != nJurX_Told)
     {
      nJurX_reset = -1;
      //--+       JurX_limit  JurX_Series()
      if (nJurX_Tnew > nJurX_Told)
       {
        Print(StringConcatenate("JurXSeries number = ",nJurX_number,
               "_ !!!  nJurX_limit  JurX_Series()   "));
       }
      else 
       { 
        int nJurX_LimitERROR=nJurX_limit+1-iBarShift(NULL,0,nJurX_Told,TRUE);
        Print(StringConcatenate("JurX_Series number = ",nJurX_number,
             "_ !!!  nJurX_limit  JurX_Series()     ",
                                                                                 nJurX_LimitERROR));
       }
      //--+ 
      return(0);
     }
  //----+------------------------------------------------------------------------------------------------+
  }
//+---    +
if (nJurX_bar == 1)
 if (nJurX_limit != 1)
  {
   nJurX_TIME[nJurX_number] = Time[2];
   dJurX_F1[nJurX_number] = dJurX_f1[nJurX_number]; 
   dJurX_F2[nJurX_number] = dJurX_f2[nJurX_number]; 
   dJurX_F3[nJurX_number] = dJurX_f3[nJurX_number]; 
   dJurX_F4[nJurX_number] = dJurX_f4[nJurX_number]; 
   dJurX_F5[nJurX_number] = dJurX_f5[nJurX_number]; 
   dJurX_F6[nJurX_number] = dJurX_f6[nJurX_number];
  }
//+---+

//---- <<<  dJurX_JurX >>> ----------------------------------------------------------------------------------------+
dJurX_f1[nJurX_number] = dJurX_Hg[nJurX_number] * dJurX_f1[nJurX_number] + dJurX_Kg[nJurX_number] * dJurX_series;
dJurX_f2[nJurX_number] = dJurX_Kg[nJurX_number] * dJurX_f1[nJurX_number] + dJurX_Hg[nJurX_number] * dJurX_f2[nJurX_number];
dJurX_VEL1             =        1.5             * dJurX_f1[nJurX_number] -        0.5             * dJurX_f2[nJurX_number];
dJurX_f3[nJurX_number] = dJurX_Hg[nJurX_number] * dJurX_f3[nJurX_number] + dJurX_Kg[nJurX_number] * dJurX_VEL1;
dJurX_f4[nJurX_number] = dJurX_Kg[nJurX_number] * dJurX_f3[nJurX_number] + dJurX_Hg[nJurX_number] * dJurX_f4[nJurX_number];
dJurX_VEL2             =        1.5             * dJurX_f3[nJurX_number] -        0.5             * dJurX_f4[nJurX_number];
dJurX_f5[nJurX_number] = dJurX_Hg[nJurX_number] * dJurX_f5[nJurX_number] + dJurX_Kg[nJurX_number] * dJurX_VEL2;
dJurX_f6[nJurX_number] = dJurX_Kg[nJurX_number] * dJurX_f5[nJurX_number] + dJurX_Hg[nJurX_number] * dJurX_f6[nJurX_number];
dJurX_JurX              =       1.5             * dJurX_f5[nJurX_number] -        0.5             * dJurX_f6[nJurX_number];
//---- ----------------------------------------------------------------------------------------------------------------------+

//----++         JurXSeries()
nJurX_Error = GetLastError();
if(nJurX_Error > 4000)
  {
    Print(StringConcatenate("JurXSeries number = ",nJurX_number,
                                    "_    JurXSeries()  !!!"));
    Print(StringConcatenate("JurXSeries number = ",nJurX_number,"_ ",JurX_ErrDescr(nJurX_Error)));  
    return(0.0);
  }
nJurX_reset = 0;
if (nJurX_bar < nJurX_MaxBar - nJurX_Length)
                                   return(dJurX_JurX);
else return(0.0);

//----     JurX_Series -------+ 
}
//+X=============================================================================================X+
// JurXSeriesResize -              | 
//  JurXSeries_  : JurXSeriesResize(5);  5 -      | 
// JurXSeries()  _      JurXSeriesResize     |
//                                        |
//+X=============================================================================================X+
int JurXSeriesResize(int nJurXResize_Size)
 {
//----+
  if(nJurXResize_Size < 1)
   {
    Print("JurXSeriesResize: !!!  nJurXResize_Size     !!!"); 
    nJurX_Resize = -1; 
    return(0);
   }  
  int nJurXResize_reset,nJurXResize_cycle;
  //--+
  while(nJurXResize_cycle == 0)
   {
    //----++ <<<     >>>  +---------------------+
    if(ArrayResize(dJurX_f1,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_f2,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_f3,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_f4,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_f5,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_f6,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_Kg,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_Hg,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F1,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F2,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F3,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F4,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F5,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(dJurX_F6,   nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(nJurX_w,    nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    if(ArrayResize(nJurX_TIME, nJurXResize_Size) == 0){nJurXResize_Size = -1; break;}
    //----++------------------------------------------------------------------------+
    nJurXResize_cycle = 1;
   }
  //--+
  if(nJurXResize_reset == -1)
   {
    Print(StringConcatenate("JurXSeriesResize: !!!",
                    "        JurXSeries()_"));
    int nJurXResize_Error = GetLastError();
    if(nJurXResize_Error > 4000)
                Print(StringConcatenate("JurXSeriesResize: ",JurX_ErrDescr(nJurXResize_Error)));             
    nJurX_Resize = -2;
    return(0);
   }
  else  
   {
    Print(StringConcatenate("JurXSeriesResize: JurXSeries Size = ",nJurXResize_Size));                                                                                                               
    nJurX_Resize = nJurXResize_Size;
    return(nJurXResize_Size);
   }  
//----+
 }

/*
//+X==================================================================================================X+
JurXSeriesAlert -                   |
 JurSeries_                                                                                     |
  --------------------------    --------------------------                             |
JurXSeriesAlert_Number                                                                                 |
JurXSeriesAlert_ExternVar      nJurX_Phase                        |
JurXSeriesAlert_name      nJurX_Length,  JurXSeriesAlert_Number=0_ |                                                  
  --------------------------    -----------------------                             |
  int init()                                                                                           |
//----                                                                                                 |
 -                                                          |
                                                                                                       |
//----                                          |                                                           
JurXSeriesAlert(0,"Length1",Length1);                                                                  |
JurXSeriesAlert(0,"Length2",Length2);                                                                  |
//----                                                                          |
return(0);                                                                                             |
}                                                                                                      |
//+X==================================================================================================X+
*/
void JurXSeriesAlert
 (
  int JurXSeriesAlert_Number, string JurXSeriesAlert_name, int JurXSeriesAlert_ExternVar
 )
 {
  //----        ==========================+ 
   if(JurXSeriesAlert_Number == 0)
     if(JurXSeriesAlert_ExternVar < 1)
          {Alert(StringConcatenate(" ",JurXSeriesAlert_name,"     1", 
                  "    ",JurXSeriesAlert_ExternVar,"    1"));}
 }

//     01_12_2006  
//+X================================================================X+
//|                                      JurX_ErrDescr_RUS(MQL4)_mqh |
//|                      Copyright  2004, MetaQuotes Software Corp_ |
//|                                       http://www_metaquotes_net/ |
//+X================================================================X+
string JurX_ErrDescr(int error_code)
 {
  string error_string;
//----
  switch(error_code)
    {
     //---- MQL4  
     case 4000: error_string = StringConcatenate("  = ",error_code,"_  ");                                                  break;
     case 4001: error_string = StringConcatenate("  = ",error_code,"_   ");                              break;
     case 4002: error_string = StringConcatenate("  = ",error_code,"_      ");                 break;
     case 4003: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     case 4004: error_string = StringConcatenate("  = ",error_code,"_     ");                break;
     case 4005: error_string = StringConcatenate("  = ",error_code,"_       ");                 break;
     case 4006: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4007: error_string = StringConcatenate("  = ",error_code,"_     ");                             break;
     case 4008: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4009: error_string = StringConcatenate("  = ",error_code,"_    ");                       break;
     case 4010: error_string = StringConcatenate("  = ",error_code,"_     ");                           break;
     case 4011: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4012: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4013: error_string = StringConcatenate("  = ",error_code,"_   ");                                             break;
     case 4014: error_string = StringConcatenate("  = ",error_code,"_  ");                                         break;
     case 4015: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                break;
     case 4016: error_string = StringConcatenate("  = ",error_code,"_  ");                                 break;
     case 4017: error_string = StringConcatenate("  = ",error_code,"_  DLL  ");                                     break;
     case 4018: error_string = StringConcatenate("  = ",error_code,"_   ");                             break;
     case 4019: error_string = StringConcatenate("  = ",error_code,"_   ");                                  break;
     case 4020: error_string = StringConcatenate("  = ",error_code,"_      ");            break;
     case 4021: error_string = StringConcatenate("  = ",error_code,"_    ,   ");     break;
     case 4022: error_string = StringConcatenate("  = ",error_code,"_   (never generated error)");                      break;
     case 4050: error_string = StringConcatenate("  = ",error_code,"_    ");                  break;
     case 4051: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4052: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4053: error_string = StringConcatenate("  = ",error_code,"_  ");                                              break;
     case 4054: error_string = StringConcatenate("  = ",error_code,"_   -");                break;
     case 4055: error_string = StringConcatenate("  = ",error_code,"_   ");                         break;
     case 4056: error_string = StringConcatenate("  = ",error_code,"_  ");                                        break;
     case 4057: error_string = StringConcatenate("  = ",error_code,"_    ");                     break;
     case 4058: error_string = StringConcatenate("  = ",error_code,"_    ");                         break;
     case 4059: error_string = StringConcatenate("  = ",error_code,"_      ");                      break;
     case 4060: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4061: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4062: error_string = StringConcatenate("  = ",error_code,"_    string");                              break;
     case 4063: error_string = StringConcatenate("  = ",error_code,"_    integer");                             break;
     case 4064: error_string = StringConcatenate("  = ",error_code,"_    double");                              break;
     case 4065: error_string = StringConcatenate("  = ",error_code,"_     ");                       break;
     case 4066: error_string = StringConcatenate("  = ",error_code,"_      ");      break;
     case 4067: error_string = StringConcatenate("  = ",error_code,"_     ");                     break;
     case 4099: error_string = StringConcatenate("  = ",error_code,"_  ");                                                 break;
     case 4100: error_string = StringConcatenate("  = ",error_code,"_     ");                                  break;
     case 4101: error_string = StringConcatenate("  = ",error_code,"_   ");                                      break;
     case 4102: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4103: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4104: error_string = StringConcatenate("  = ",error_code,"_     ");                         break;
     case 4105: error_string = StringConcatenate("  = ",error_code,"_     ");                                     break;
     case 4106: error_string = StringConcatenate("  = ",error_code,"_  ");                                          break;
     case 4107: error_string = StringConcatenate("  = ",error_code,"_      ");             break;
     case 4108: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4109: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4110: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4111: error_string = StringConcatenate("  = ",error_code,"_    ");                               break;
     case 4200: error_string = StringConcatenate("  = ",error_code,"_   ");                                       break;
     case 4201: error_string = StringConcatenate("  = ",error_code,"_    ");                      break;
     case 4202: error_string = StringConcatenate("  = ",error_code,"_   ");                                        break;
     case 4203: error_string = StringConcatenate("  = ",error_code,"_   ");                                     break;
     case 4204: error_string = StringConcatenate("  = ",error_code,"_   ");                                           break;
     case 4205: error_string = StringConcatenate("  = ",error_code,"_   ");                                    break;
     case 4206: error_string = StringConcatenate("  = ",error_code,"_    ");                                break;
     case 4207: error_string = StringConcatenate("  = ",error_code,"_     ");                                break;
     default:   error_string = StringConcatenate("  = ",error_code,"_  ");
    }
//----
  return(error_string);
 }
//+------------------------------------------------------------------+


